interface BaseExerciseInterface {
    locked: boolean;
    instruction: string;
    currentPoolIndex: number;
    currentPoolItemIndex: number;
    pool: Element;

    // private
    currentSemaphore: number;
    numSemaphores: number;

    // Hooks (triggered by player)
    initialize();
    nextStep();
    sameStep();
    reset();
    dispose();
    showWrongFeedback();
    showCorrectFeedback();
    setLocked(value: boolean);

    // Hooks implemented in base
    setPoolXml(poolXml: string);
    setLogDisabled(value: Boolean): void;
    setCurrentPoolIndex(index: number);
    setCurrentPoolItemIndex(index: number);
    setLocaleDictionary(dictionary: any);
    setInstruction(instruction: string);
    // setCurrentSemaphore(value: number): void; FIXME
    // setNumSemaphores(value: number): void; FIXME

    // Player notifiers
    notifyAnswer(correct: boolean);
    notifyFeedbackCompleted();

    // Utils
    getInstruction(): string;
    getPool(): Element;
    getCurrentPoolItem(): Element;
    getCurrentPool(): Element;
    isSemaphoreLast(): boolean;
    getNumSemaphores(): number;
    getCurrentSemaphoreIndex(): number;
}
